' Key Archival Enrollment Script

' Requires the installation of CAPICOM.DLL on the client computer
' Please change the values in strMachineConfig1 and strUserConfig1
'
' This script is provided "As is", no technical assistance will be offered
' 
' Microsoft(C) Corporation 2004


Option Explicit

Const AT_KEYEXCHANGE = 1
Const AT_SIGNATURE = 2
Const CRYPT_ARCHIVABLE = &H000004000
Const CRYPT_EXPORTABLE = 1
Const RSA1024BIT_KEY = &H04000000

Const XECR_PKCS10_V2_0 = 1
Const XECR_PKCS7       = 2
Const XECR_CMC         = 3
Const XECR_PKCS10_V1_5 = 4

Const CR_OUT_BASE64HEADER = 0
Const CR_OUT_BASE64 = 1
Const CR_OUT_BINARY = 2
Const CR_OUT_CHAIN  = &h100

Const CR_IN_BASE64HEADER = 0
Const CR_IN_BASE64 = &H1
Const CR_IN_PKCS10 = &H100
Const CR_IN_KEYGEN = &H200
Const CR_IN_ENCODEANY = &Hff
Const CR_IN_FORMATANY = 0
Const CR_IN_FULLRESPONSE = &H40000
Const CR_IN_RPC = &H20000

Const CR_DISP_INCOMPLETE = 0
Const CR_DISP_ERROR = 1
Const CR_DISP_DENIED = 2
Const CR_DISP_ISSUED = 3
Const CR_DISP_ISSUED_OUT_OF_BAND = 4
Const CR_DISP_UNDER_SUBMISSION = 5
Const CR_DISP_REVOKED = 6


Const PROPTYPE_LONG = 1
Const PROPTYPE_DATE = 2
Const PROPTYPE_BINARY = 3
Const PROPTYPE_STRING = 4


Const CR_GEMT_HRESULT_STRING = 1

Const FR_PROP_NONE                    = 0  ' Invalid
Const FR_PROP_FULLRESPONSE            = 1  ' Binary
Const FR_PROP_STATUSINFOCOUNT         = 2  ' Long
Const FR_PROP_BODYPARTSTRING          = 3  ' String, Indexed
Const FR_PROP_STATUS                  = 4  ' Long, Indexed
Const FR_PROP_STATUSSTRING            = 5  ' String, Indexed
Const FR_PROP_OTHERINFOCHOICE         = 6  ' Long, Indexed
Const FR_PROP_FAILINFO                = 7  ' Long, Indexed
Const FR_PROP_PENDINFOTOKEN           = 8  ' Binary, Indexed
Const FR_PROP_PENDINFOTIME            = 9  ' Date, Indexed
Const FR_PROP_ISSUEDCERTIFICATEHASH   =10  ' Binary, Indexed
Const FR_PROP_ISSUEDCERTIFICATE       =11  ' Binary, Indexed
Const FR_PROP_ISSUEDCERTIFICATECHAIN  =12  ' Binary, Indexed
Const FR_PROP_ISSUEDCERTIFICATECRLCHAIN=13  ' Binary, Indexed
Const FR_PROP_ENCRYPTEDKEYHASH	      =14  ' Binary, Indexed
Const FR_PROP_FULLRESPONSENOPKCS7	  =15  ' Binary



Const KeyLength = 1024

'Const StrCAConfig = "COMPUTERNAME\CA Name"
 Const StrCAConfig = "issuingca.example.com\Example Corporation Issuing CA"

Dim CertEnroll, CertRequest, CACert


Set CertEnroll = CreateObject( "CEnroll.CEnroll.2" )


CertEnroll.ProviderName = "Microsoft Enhanced Cryptographic Provider v1.0"
CertEnroll.KeySpec = AT_KEYEXCHANGE
CertEnroll.GenKeyFlags = (KeyLength * 256*256) Or CRYPT_EXPORTABLE
CertEnroll.EnableSMIMECapabilities = False
CertEnroll.addCertTypeToRequest "EmailEncrypt"


' Add the private key to the request.
Set CertRequest = CreateObject( "CertificateAuthority.Request" )
CACert = CertRequest.GetCACertificate( 1, StrCAConfig, CR_OUT_BASE64 )
CertEnroll.PrivateKeyArchiveCertificate = CACert


' Finally Create the request
Dim RequestStr, Disposition, ID
RequestStr = CertEnroll.createRequest( XECR_CMC, "",  "" )


' Send the request to the CA
Disposition = CertRequest.Submit( CR_IN_ENCODEANY Or CR_IN_FORMATANY Or CR_IN_RPC Or CR_IN_FULLRESPONSE, RequestStr, "", StrCAConfig )
ID = CertRequest.GetRequestId


' Show the Request ID
WScript.echo "Request Id = " + cstr(ID)


If Disposition = CR_DISP_ISSUED Then
	Dim Cert

              Cert = CertRequest.GetCertificate(CR_OUT_CHAIN)
	
	CertEnroll.acceptResponse Cert
Else
	WScript.echo "Disposition = " + cstr( Disposition )
	If CertRequest.GetLastStatus <> 0 Then
		WScript.echo "Request Failed"
	End If
End If



